
_interrupt:
	CLRF       PCLATH+0
	CLRF       STATUS+0

;12F1840_PWM_UART_140510.c,134 :: 		void interrupt(void)  org 0x04
;12F1840_PWM_UART_140510.c,136 :: 		if ( (RCIE_bit) && ( RCIF_bit))
	BTFSS      RCIE_bit+0, BitPos(RCIE_bit+0)
	GOTO       L_interrupt2
	BTFSS      RCIF_bit+0, BitPos(RCIF_bit+0)
	GOTO       L_interrupt2
L__interrupt41:
;12F1840_PWM_UART_140510.c,139 :: 		if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
	BTFSS      RCSTA+0, 1
	GOTO       L_interrupt3
;12F1840_PWM_UART_140510.c,141 :: 		RCSTA.CREN = 0 ;
	BCF        RCSTA+0, 4
;12F1840_PWM_UART_140510.c,142 :: 		c1 = RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _c1+0
;12F1840_PWM_UART_140510.c,143 :: 		RCSTA.CREN = 1 ;
	BSF        RCSTA+0, 4
;12F1840_PWM_UART_140510.c,144 :: 		CptErr++;
	MOVLW      1
	ADDWF      _CptErr+0, 0
	MOVWF      R0
	MOVLW      0
	ADDWFC     _CptErr+1, 0
	MOVWF      R1
	MOVF       R0, 0
	MOVWF      _CptErr+0
	MOVF       R1, 0
	MOVWF      _CptErr+1
;12F1840_PWM_UART_140510.c,146 :: 		}
L_interrupt3:
;12F1840_PWM_UART_140510.c,147 :: 		if(RCSTA.FERR==1 )
	BTFSS      RCSTA+0, 2
	GOTO       L_interrupt4
;12F1840_PWM_UART_140510.c,149 :: 		RCSTA.SPEN = 0 ;
	BCF        RCSTA+0, 7
;12F1840_PWM_UART_140510.c,150 :: 		RCSTA.SPEN= 1 ;
	BSF        RCSTA+0, 7
;12F1840_PWM_UART_140510.c,151 :: 		CptErr++;
	MOVLW      1
	ADDWF      _CptErr+0, 0
	MOVWF      R0
	MOVLW      0
	ADDWFC     _CptErr+1, 0
	MOVWF      R1
	MOVF       R0, 0
	MOVWF      _CptErr+0
	MOVF       R1, 0
	MOVWF      _CptErr+1
;12F1840_PWM_UART_140510.c,152 :: 		c1 = RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _c1+0
;12F1840_PWM_UART_140510.c,153 :: 		}
L_interrupt4:
;12F1840_PWM_UART_140510.c,154 :: 		c1 = RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _c1+0
;12F1840_PWM_UART_140510.c,155 :: 		if (c1==CR)
	MOVF       _c1+0, 0
	XORLW      13
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt5
;12F1840_PWM_UART_140510.c,157 :: 		Flag_Buffer=1;
	MOVLW      1
	MOVWF      _Flag_Buffer+0
	MOVLW      0
	MOVWF      _Flag_Buffer+1
;12F1840_PWM_UART_140510.c,159 :: 		buffer[i1]=0;
	MOVLW      _buffer+0
	ADDWF      _i1+0, 0
	MOVWF      FSR1L
	MOVLW      hi_addr(_buffer+0)
	ADDWFC     _i1+1, 0
	MOVWF      FSR1H
	CLRF       INDF1+0
;12F1840_PWM_UART_140510.c,160 :: 		Index1=i1;
	MOVF       _i1+0, 0
	MOVWF      _Index1+0
	MOVF       _i1+1, 0
	MOVWF      _Index1+1
;12F1840_PWM_UART_140510.c,161 :: 		i1=0;
	CLRF       _i1+0
	CLRF       _i1+1
;12F1840_PWM_UART_140510.c,162 :: 		c1=0;
	CLRF       _c1+0
;12F1840_PWM_UART_140510.c,163 :: 		}
	GOTO       L_interrupt6
L_interrupt5:
;12F1840_PWM_UART_140510.c,166 :: 		buffer[i1]=c1;
	MOVLW      _buffer+0
	ADDWF      _i1+0, 0
	MOVWF      FSR1L
	MOVLW      hi_addr(_buffer+0)
	ADDWFC     _i1+1, 0
	MOVWF      FSR1H
	MOVF       _c1+0, 0
	MOVWF      INDF1+0
;12F1840_PWM_UART_140510.c,167 :: 		Index1=i1;
	MOVF       _i1+0, 0
	MOVWF      _Index1+0
	MOVF       _i1+1, 0
	MOVWF      _Index1+1
;12F1840_PWM_UART_140510.c,168 :: 		i1++;
	MOVLW      1
	ADDWF      _i1+0, 0
	MOVWF      R0
	MOVLW      0
	ADDWFC     _i1+1, 0
	MOVWF      R1
	MOVF       R0, 0
	MOVWF      _i1+0
	MOVF       R1, 0
	MOVWF      _i1+1
;12F1840_PWM_UART_140510.c,170 :: 		}
L_interrupt6:
;12F1840_PWM_UART_140510.c,171 :: 		PIR1.RCIF=0   ;
	BCF        PIR1+0, 5
;12F1840_PWM_UART_140510.c,172 :: 		}
L_interrupt2:
;12F1840_PWM_UART_140510.c,174 :: 		if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
	BTFSS      TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
	GOTO       L_interrupt9
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L_interrupt9
L__interrupt40:
;12F1840_PWM_UART_140510.c,177 :: 		Count1++;
	MOVLW      1
	ADDWF      _Count1+0, 0
	MOVWF      R0
	MOVLW      0
	ADDWFC     _Count1+1, 0
	MOVWF      R1
	MOVF       R0, 0
	MOVWF      _Count1+0
	MOVF       R1, 0
	MOVWF      _Count1+1
;12F1840_PWM_UART_140510.c,178 :: 		if (Count1>=NbCycles_T1)   // 8x125 ms= 1 seconde   et init timer1  3035  et prescaler=1/8
	MOVLW      0
	SUBWF      _Count1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt45
	MOVLW      8
	SUBWF      _Count1+0, 0
L__interrupt45:
	BTFSS      STATUS+0, 0
	GOTO       L_interrupt10
;12F1840_PWM_UART_140510.c,180 :: 		Count1=0;
	CLRF       _Count1+0
	CLRF       _Count1+1
;12F1840_PWM_UART_140510.c,181 :: 		Flag_Timer1=1;
	MOVLW      1
	MOVWF      _Flag_Timer1+0
	MOVLW      0
	MOVWF      _Flag_Timer1+1
;12F1840_PWM_UART_140510.c,182 :: 		TMR1IE_bit=0;
	BCF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;12F1840_PWM_UART_140510.c,183 :: 		}
L_interrupt10:
;12F1840_PWM_UART_140510.c,184 :: 		TMR1H= 0x0B; // Hi (3035);
	MOVLW      11
	MOVWF      TMR1H+0
;12F1840_PWM_UART_140510.c,185 :: 		TMR1L= 0xDB; // Lo (3035);
	MOVLW      219
	MOVWF      TMR1L+0
;12F1840_PWM_UART_140510.c,186 :: 		PIR1.TMR1IF=0;
	BCF        PIR1+0, 0
;12F1840_PWM_UART_140510.c,187 :: 		}
L_interrupt9:
;12F1840_PWM_UART_140510.c,204 :: 		}
L_end_interrupt:
L__interrupt44:
	RETFIE     %s
; end of _interrupt

_strConstRamCpy:

;12F1840_PWM_UART_140510.c,207 :: 		void strConstRamCpy(unsigned char *dest, const code char *source) {
;12F1840_PWM_UART_140510.c,208 :: 		while (*source)*dest++ = *source++ ;
L_strConstRamCpy11:
	MOVF       FARG_strConstRamCpy_source+0, 0
	MOVWF      FSR0L
	MOVF       FARG_strConstRamCpy_source+1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      R0
	MOVF       R0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_strConstRamCpy12
	MOVF       FARG_strConstRamCpy_source+0, 0
	MOVWF      FSR0L
	MOVF       FARG_strConstRamCpy_source+1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      R0
	MOVF       FARG_strConstRamCpy_dest+0, 0
	MOVWF      FSR1L
	MOVF       FARG_strConstRamCpy_dest+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
	INCF       FARG_strConstRamCpy_dest+0, 1
	BTFSC      STATUS+0, 2
	INCF       FARG_strConstRamCpy_dest+1, 1
	INCF       FARG_strConstRamCpy_source+0, 1
	BTFSC      STATUS+0, 2
	INCF       FARG_strConstRamCpy_source+1, 1
	GOTO       L_strConstRamCpy11
L_strConstRamCpy12:
;12F1840_PWM_UART_140510.c,209 :: 		*dest = 0 ;    // terminateur
	MOVF       FARG_strConstRamCpy_dest+0, 0
	MOVWF      FSR1L
	MOVF       FARG_strConstRamCpy_dest+1, 0
	MOVWF      FSR1H
	CLRF       INDF1+0
;12F1840_PWM_UART_140510.c,210 :: 		}
L_end_strConstRamCpy:
	RETURN
; end of _strConstRamCpy

_CRLF:

;12F1840_PWM_UART_140510.c,212 :: 		void CRLF()
;12F1840_PWM_UART_140510.c,214 :: 		UART1_Write(CR);
	MOVLW      13
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;12F1840_PWM_UART_140510.c,215 :: 		UART1_Write(LF);
	MOVLW      10
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;12F1840_PWM_UART_140510.c,216 :: 		}
L_end_CRLF:
	RETURN
; end of _CRLF

_UART1_Write_CText:

;12F1840_PWM_UART_140510.c,218 :: 		void UART1_Write_CText(const char *txt) {
;12F1840_PWM_UART_140510.c,219 :: 		while (*txt)
L_UART1_Write_CText13:
	MOVF       FARG_UART1_Write_CText_txt+0, 0
	MOVWF      FSR0L
	MOVF       FARG_UART1_Write_CText_txt+1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      R0
	MOVF       R0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_UART1_Write_CText14
;12F1840_PWM_UART_140510.c,220 :: 		UART1_Write(*txt++);
	MOVF       FARG_UART1_Write_CText_txt+0, 0
	MOVWF      FSR0L
	MOVF       FARG_UART1_Write_CText_txt+1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	INCF       FARG_UART1_Write_CText_txt+0, 1
	BTFSC      STATUS+0, 2
	INCF       FARG_UART1_Write_CText_txt+1, 1
	GOTO       L_UART1_Write_CText13
L_UART1_Write_CText14:
;12F1840_PWM_UART_140510.c,221 :: 		}
L_end_UART1_Write_CText:
	RETURN
; end of _UART1_Write_CText

_Read_Msg_Eeprom:

;12F1840_PWM_UART_140510.c,224 :: 		void Read_Msg_Eeprom(unsigned char debut)
;12F1840_PWM_UART_140510.c,226 :: 		i1=debut;
	MOVF       FARG_Read_Msg_Eeprom_debut+0, 0
	MOVWF      Read_Msg_Eeprom_i1_L0+0
	CLRF       Read_Msg_Eeprom_i1_L0+1
;12F1840_PWM_UART_140510.c,227 :: 		do
L_Read_Msg_Eeprom15:
;12F1840_PWM_UART_140510.c,229 :: 		i = EEPROM_Read(i1);
	MOVF       Read_Msg_Eeprom_i1_L0+0, 0
	MOVWF      FARG_EEPROM_Read_Address+0
	CALL       _EEPROM_Read+0
	MOVF       R0, 0
	MOVWF      Read_Msg_Eeprom_i_L0+0
	CLRF       Read_Msg_Eeprom_i_L0+1
;12F1840_PWM_UART_140510.c,230 :: 		if ( i==0) break;
	MOVLW      0
	XORWF      Read_Msg_Eeprom_i_L0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Read_Msg_Eeprom50
	MOVLW      0
	XORWF      Read_Msg_Eeprom_i_L0+0, 0
L__Read_Msg_Eeprom50:
	BTFSS      STATUS+0, 2
	GOTO       L_Read_Msg_Eeprom18
	GOTO       L_Read_Msg_Eeprom16
L_Read_Msg_Eeprom18:
;12F1840_PWM_UART_140510.c,231 :: 		if ( i1>254) break;
	MOVLW      128
	MOVWF      R0
	MOVLW      128
	XORWF      Read_Msg_Eeprom_i1_L0+1, 0
	SUBWF      R0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Read_Msg_Eeprom51
	MOVF       Read_Msg_Eeprom_i1_L0+0, 0
	SUBLW      254
L__Read_Msg_Eeprom51:
	BTFSC      STATUS+0, 0
	GOTO       L_Read_Msg_Eeprom19
	GOTO       L_Read_Msg_Eeprom16
L_Read_Msg_Eeprom19:
;12F1840_PWM_UART_140510.c,232 :: 		UART1_Write(i);
	MOVF       Read_Msg_Eeprom_i_L0+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;12F1840_PWM_UART_140510.c,233 :: 		delay_ms(5);
	MOVLW      26
	MOVWF      R12
	MOVLW      248
	MOVWF      R13
L_Read_Msg_Eeprom20:
	DECFSZ     R13, 1
	GOTO       L_Read_Msg_Eeprom20
	DECFSZ     R12, 1
	GOTO       L_Read_Msg_Eeprom20
	NOP
;12F1840_PWM_UART_140510.c,234 :: 		i1++;
	INCF       Read_Msg_Eeprom_i1_L0+0, 1
	BTFSC      STATUS+0, 2
	INCF       Read_Msg_Eeprom_i1_L0+1, 1
;12F1840_PWM_UART_140510.c,236 :: 		while (i!=0) ;
	MOVLW      0
	XORWF      Read_Msg_Eeprom_i_L0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Read_Msg_Eeprom52
	MOVLW      0
	XORWF      Read_Msg_Eeprom_i_L0+0, 0
L__Read_Msg_Eeprom52:
	BTFSS      STATUS+0, 2
	GOTO       L_Read_Msg_Eeprom15
L_Read_Msg_Eeprom16:
;12F1840_PWM_UART_140510.c,237 :: 		}
L_end_Read_Msg_Eeprom:
	RETURN
; end of _Read_Msg_Eeprom

_Init_Timer0:

;12F1840_PWM_UART_140510.c,239 :: 		void Init_Timer0(void)    // 1 seconde
;12F1840_PWM_UART_140510.c,242 :: 		OPTION_REG.PS2=1;   // prescaler 1/256
	BSF        OPTION_REG+0, 2
;12F1840_PWM_UART_140510.c,243 :: 		OPTION_REG.PS1=1;
	BSF        OPTION_REG+0, 1
;12F1840_PWM_UART_140510.c,244 :: 		OPTION_REG.PS0=1;
	BSF        OPTION_REG+0, 0
;12F1840_PWM_UART_140510.c,245 :: 		OPTION_REG.PSA=0; // prescaler sur Timer0
	BCF        OPTION_REG+0, 3
;12F1840_PWM_UART_140510.c,246 :: 		OPTION_REG.TMR0CS=0; // source FOSC/4
	BCF        OPTION_REG+0, 5
;12F1840_PWM_UART_140510.c,247 :: 		INTCON.TMR0IF=0;
	BCF        INTCON+0, 2
;12F1840_PWM_UART_140510.c,248 :: 		INTCON.TMR0IE=0;    // disable interrupt Timer0
	BCF        INTCON+0, 5
;12F1840_PWM_UART_140510.c,249 :: 		TMR0= 255 ; //  255-0=255  prescaler=1/256 => 16.384 mS
	MOVLW      255
	MOVWF      TMR0+0
;12F1840_PWM_UART_140510.c,250 :: 		CPSCON0=0;
	CLRF       CPSCON0+0
;12F1840_PWM_UART_140510.c,251 :: 		}
L_end_Init_Timer0:
	RETURN
; end of _Init_Timer0

_Init_Timer1:

;12F1840_PWM_UART_140510.c,253 :: 		void Init_Timer1(void)
;12F1840_PWM_UART_140510.c,255 :: 		T1CON=0;
	CLRF       T1CON+0
;12F1840_PWM_UART_140510.c,257 :: 		TMR1CS0_bit=0;   // FOSC internal / 4
	BCF        TMR1CS0_bit+0, BitPos(TMR1CS0_bit+0)
;12F1840_PWM_UART_140510.c,258 :: 		TMR1CS1_bit=0;
	BCF        TMR1CS1_bit+0, BitPos(TMR1CS1_bit+0)
;12F1840_PWM_UART_140510.c,259 :: 		T1CKPS1_bit=1;  //prescal select=11 => 1/8
	BSF        T1CKPS1_bit+0, BitPos(T1CKPS1_bit+0)
;12F1840_PWM_UART_140510.c,260 :: 		T1CKPS0_bit=1;
	BSF        T1CKPS0_bit+0, BitPos(T1CKPS0_bit+0)
;12F1840_PWM_UART_140510.c,261 :: 		T1GCON=0;
	CLRF       T1GCON+0
;12F1840_PWM_UART_140510.c,262 :: 		TMR1H= 0x0B; // Hi (3035);
	MOVLW      11
	MOVWF      TMR1H+0
;12F1840_PWM_UART_140510.c,263 :: 		TMR1L= 0xDB; // Lo (3035);
	MOVLW      219
	MOVWF      TMR1L+0
;12F1840_PWM_UART_140510.c,266 :: 		Count1=0;
	CLRF       _Count1+0
	CLRF       _Count1+1
;12F1840_PWM_UART_140510.c,267 :: 		Flag_Timer1=0;
	CLRF       _Flag_Timer1+0
	CLRF       _Flag_Timer1+1
;12F1840_PWM_UART_140510.c,268 :: 		PIR1.TMR1IF=0;     // Reset Timer1 Flag
	BCF        PIR1+0, 0
;12F1840_PWM_UART_140510.c,269 :: 		PIE1.TMR1IE=1;  //Enable interrupt TMR1
	BSF        PIE1+0, 0
;12F1840_PWM_UART_140510.c,270 :: 		TMR1ON_bit=1;
	BSF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;12F1840_PWM_UART_140510.c,271 :: 		}
L_end_Init_Timer1:
	RETURN
; end of _Init_Timer1

_Init_Timer2:

;12F1840_PWM_UART_140510.c,273 :: 		void Init_Timer2(void)
;12F1840_PWM_UART_140510.c,275 :: 		T2CON=0;
	CLRF       T2CON+0
;12F1840_PWM_UART_140510.c,276 :: 		T2OUTPS0_bit=1;     // postscaleer =1/16
	BSF        T2OUTPS0_bit+0, BitPos(T2OUTPS0_bit+0)
;12F1840_PWM_UART_140510.c,277 :: 		T2OUTPS1_bit=1;
	BSF        T2OUTPS1_bit+0, BitPos(T2OUTPS1_bit+0)
;12F1840_PWM_UART_140510.c,278 :: 		T2OUTPS2_bit=1;
	BSF        T2OUTPS2_bit+0, BitPos(T2OUTPS2_bit+0)
;12F1840_PWM_UART_140510.c,279 :: 		T2OUTPS3_bit=1;
	BSF        T2OUTPS3_bit+0, BitPos(T2OUTPS3_bit+0)
;12F1840_PWM_UART_140510.c,280 :: 		T2CKPS1_bit=1;  //prescaler select=11 => 1/64
	BSF        T2CKPS1_bit+0, BitPos(T2CKPS1_bit+0)
;12F1840_PWM_UART_140510.c,281 :: 		T2CKPS0_bit=1;
	BSF        T2CKPS0_bit+0, BitPos(T2CKPS0_bit+0)
;12F1840_PWM_UART_140510.c,282 :: 		TMR2=   60;     // 49.92mS @ 16MHz
	MOVLW      60
	MOVWF      TMR2+0
;12F1840_PWM_UART_140510.c,283 :: 		Count2=0;
	CLRF       _Count2+0
	CLRF       _Count2+1
;12F1840_PWM_UART_140510.c,284 :: 		Flag_Timer2=0;
	CLRF       _Flag_Timer2+0
	CLRF       _Flag_Timer2+1
;12F1840_PWM_UART_140510.c,285 :: 		TMR2IF_bit=0;     // Reset Timer1 Flag
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
;12F1840_PWM_UART_140510.c,286 :: 		TMR2IE_bit=0;  //Enable interrupt TMR1
	BCF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
;12F1840_PWM_UART_140510.c,287 :: 		TMR2ON_bit=1;
	BSF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
;12F1840_PWM_UART_140510.c,288 :: 		}
L_end_Init_Timer2:
	RETURN
; end of _Init_Timer2

_ValToLevel:

;12F1840_PWM_UART_140510.c,290 :: 		char ValToLevel(char val) {
;12F1840_PWM_UART_140510.c,291 :: 		char i = 0;
	CLRF       ValToLevel_i_L0+0
;12F1840_PWM_UART_140510.c,292 :: 		while (i < sizeof(levels)) {
L_ValToLevel21:
	MOVLW      8
	SUBWF      ValToLevel_i_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ValToLevel22
;12F1840_PWM_UART_140510.c,293 :: 		if (val < levels[i])
	MOVLW      _levels+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_levels+0)
	MOVWF      FSR0H
	MOVF       ValToLevel_i_L0+0, 0
	ADDWF      FSR0L, 1
	BTFSC      STATUS+0, 0
	INCF       FSR0H, 1
	MOVF       INDF0+0, 0
	MOVWF      R1
	MOVF       R1, 0
	SUBWF      FARG_ValToLevel_val+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ValToLevel23
;12F1840_PWM_UART_140510.c,294 :: 		return i;
	MOVF       ValToLevel_i_L0+0, 0
	MOVWF      R0
	GOTO       L_end_ValToLevel
L_ValToLevel23:
;12F1840_PWM_UART_140510.c,295 :: 		i++;
	INCF       ValToLevel_i_L0+0, 1
;12F1840_PWM_UART_140510.c,296 :: 		}
	GOTO       L_ValToLevel21
L_ValToLevel22:
;12F1840_PWM_UART_140510.c,298 :: 		return sizeof(levels);
	MOVLW      8
	MOVWF      R0
;12F1840_PWM_UART_140510.c,299 :: 		}
L_end_ValToLevel:
	RETURN
; end of _ValToLevel

_main:

;12F1840_PWM_UART_140510.c,301 :: 		void main(void)
;12F1840_PWM_UART_140510.c,306 :: 		OSCCON=0b01111010;    // choix 16Mhz  internal osc
	MOVLW      122
	MOVWF      OSCCON+0
;12F1840_PWM_UART_140510.c,307 :: 		ANSELA=0;             // no analog
	CLRF       ANSELA+0
;12F1840_PWM_UART_140510.c,308 :: 		ANSELA.ANSA4=1;       // RA4= Analog input
	BSF        ANSELA+0, 4
;12F1840_PWM_UART_140510.c,309 :: 		TRISA= 0b00011111;    // RA0,1,,3,4 as input     RA2 as output PWM, RA5 as output  TX
	MOVLW      31
	MOVWF      TRISA+0
;12F1840_PWM_UART_140510.c,310 :: 		WPUA=0b00111111;      // weak pull up on RX & TX  et RA2
	MOVLW      63
	MOVWF      WPUA+0
;12F1840_PWM_UART_140510.c,311 :: 		CM1CON0=0;       // disable comparators
	CLRF       CM1CON0+0
;12F1840_PWM_UART_140510.c,312 :: 		CM1CON1=0;
	CLRF       CM1CON1+0
;12F1840_PWM_UART_140510.c,313 :: 		CCP1CON=0;       // indispensable pour UART sur RA0
	CLRF       CCP1CON+0
;12F1840_PWM_UART_140510.c,315 :: 		APFCON=0;
	CLRF       APFCON+0
;12F1840_PWM_UART_140510.c,316 :: 		APFCON.P1BSEL=1;    // pour deconnecter de RA0 mais connecte sur RA4 ???!!
	BSF        APFCON+0, 1
;12F1840_PWM_UART_140510.c,317 :: 		APFCON.RXDTSEL=0;   // RX sur RA1
	BCF        APFCON+0, 7
;12F1840_PWM_UART_140510.c,318 :: 		APFCON.TXCKSEL=0;   // TX sur RA0
	BCF        APFCON+0, 2
;12F1840_PWM_UART_140510.c,319 :: 		APFCON.CCP1SEL=0;   // PWM output pin  0=RA2   1=RA4
	BCF        APFCON+0, 0
;12F1840_PWM_UART_140510.c,323 :: 		FVRCON.FVREN=1;       // enable fixed voltage reference     (voir page 124)
	BSF        FVRCON+0, 7
;12F1840_PWM_UART_140510.c,324 :: 		FVRCON.TSEN=0;        // temperature enable=0;
	BCF        FVRCON+0, 5
;12F1840_PWM_UART_140510.c,325 :: 		FVRCON.TSRNG=1;       // temperature range high   car VDD>3,6V
	BSF        FVRCON+0, 4
;12F1840_PWM_UART_140510.c,326 :: 		FVRCON.CDAFVR1=0;     // Comparator & DAC OFF
	BCF        FVRCON+0, 3
;12F1840_PWM_UART_140510.c,327 :: 		FVRCON.CDAFVR0=0;
	BCF        FVRCON+0, 2
;12F1840_PWM_UART_140510.c,330 :: 		FVRCON.ADFVR1=1;     // ref=4.096V
	BSF        FVRCON+0, 1
;12F1840_PWM_UART_140510.c,331 :: 		FVRCON.ADFVR0=1;
	BSF        FVRCON+0, 0
;12F1840_PWM_UART_140510.c,334 :: 		RCSTA=0;
	CLRF       RCSTA+0
;12F1840_PWM_UART_140510.c,335 :: 		RCSTA.CREN=1;  //enable receiver
	BSF        RCSTA+0, 4
;12F1840_PWM_UART_140510.c,336 :: 		RCSTA.SPEN=1;  // serial port Pins Enable
	BSF        RCSTA+0, 7
;12F1840_PWM_UART_140510.c,337 :: 		RCSTA.SREN=1;  // single bit receive
	BSF        RCSTA+0, 5
;12F1840_PWM_UART_140510.c,338 :: 		c1 = RCREG;   // RAZ errors
	MOVF       RCREG+0, 0
	MOVWF      _c1+0
;12F1840_PWM_UART_140510.c,340 :: 		p1=&buffer[0];
	MOVLW      _buffer+0
	MOVWF      _p1+0
	MOVLW      hi_addr(_buffer+0)
	MOVWF      _p1+1
;12F1840_PWM_UART_140510.c,342 :: 		INTCON=0;
	CLRF       INTCON+0
;12F1840_PWM_UART_140510.c,343 :: 		PIR1=0;
	CLRF       PIR1+0
;12F1840_PWM_UART_140510.c,344 :: 		PIR2=0;
	CLRF       PIR2+0
;12F1840_PWM_UART_140510.c,345 :: 		INTCON.PEIE=1;  // disable IT des peripherique voir fig  8.1 p 77
	BSF        INTCON+0, 6
;12F1840_PWM_UART_140510.c,346 :: 		INTCON.GIE=0;
	BCF        INTCON+0, 7
;12F1840_PWM_UART_140510.c,348 :: 		txt=&Texte[0];
	MOVLW      _Texte+0
	MOVWF      _txt+0
	MOVLW      hi_addr(_Texte+0)
	MOVWF      _txt+1
;12F1840_PWM_UART_140510.c,349 :: 		UART1_Init(19200);
	BSF        BAUDCON+0, 3
	MOVLW      207
	MOVWF      SPBRG+0
	CLRF       SPBRG+1
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;12F1840_PWM_UART_140510.c,351 :: 		while(PIR1.RCIF==1) c1 = RCREG;
L_main24:
	BTFSS      PIR1+0, 5
	GOTO       L_main25
	MOVF       RCREG+0, 0
	MOVWF      _c1+0
	GOTO       L_main24
L_main25:
;12F1840_PWM_UART_140510.c,353 :: 		UART1_Write(CR);//TXREG=CLS;
	MOVLW      13
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;12F1840_PWM_UART_140510.c,354 :: 		delay_ms(1000);
	MOVLW      21
	MOVWF      R11
	MOVLW      75
	MOVWF      R12
	MOVLW      190
	MOVWF      R13
L_main26:
	DECFSZ     R13, 1
	GOTO       L_main26
	DECFSZ     R12, 1
	GOTO       L_main26
	DECFSZ     R11, 1
	GOTO       L_main26
	NOP
;12F1840_PWM_UART_140510.c,356 :: 		txt=&Texte[0];
	MOVLW      _Texte+0
	MOVWF      _txt+0
	MOVLW      hi_addr(_Texte+0)
	MOVWF      _txt+1
;12F1840_PWM_UART_140510.c,357 :: 		strConstRamCpy(txt, mesg0);
	MOVF       _txt+0, 0
	MOVWF      FARG_strConstRamCpy_dest+0
	MOVF       _txt+1, 0
	MOVWF      FARG_strConstRamCpy_dest+1
	MOVLW      _mesg0+0
	MOVWF      FARG_strConstRamCpy_source+0
	MOVLW      hi_addr(_mesg0+0)
	MOVWF      FARG_strConstRamCpy_source+1
	CALL       _strConstRamCpy+0
;12F1840_PWM_UART_140510.c,358 :: 		UART1_Write_Text(txt);
	MOVF       _txt+0, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVF       _txt+1, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;12F1840_PWM_UART_140510.c,359 :: 		delay_ms(1000);
	MOVLW      21
	MOVWF      R11
	MOVLW      75
	MOVWF      R12
	MOVLW      190
	MOVWF      R13
L_main27:
	DECFSZ     R13, 1
	GOTO       L_main27
	DECFSZ     R12, 1
	GOTO       L_main27
	DECFSZ     R11, 1
	GOTO       L_main27
	NOP
;12F1840_PWM_UART_140510.c,361 :: 		Read_Msg_Eeprom(0x0000);   txt=&Texte[0];   delay_ms(1000);
	CLRF       FARG_Read_Msg_Eeprom_debut+0
	CALL       _Read_Msg_Eeprom+0
	MOVLW      _Texte+0
	MOVWF      _txt+0
	MOVLW      hi_addr(_Texte+0)
	MOVWF      _txt+1
	MOVLW      21
	MOVWF      R11
	MOVLW      75
	MOVWF      R12
	MOVLW      190
	MOVWF      R13
L_main28:
	DECFSZ     R13, 1
	GOTO       L_main28
	DECFSZ     R12, 1
	GOTO       L_main28
	DECFSZ     R11, 1
	GOTO       L_main28
	NOP
;12F1840_PWM_UART_140510.c,363 :: 		ADC_Init();
	CALL       _ADC_Init+0
;12F1840_PWM_UART_140510.c,366 :: 		ADCON1.ADPREF1= 1;  // Vref sur FVR 4.096V
	BSF        ADCON1+0, 1
;12F1840_PWM_UART_140510.c,367 :: 		ADCON1.ADPREF0= 1;
	BSF        ADCON1+0, 0
;12F1840_PWM_UART_140510.c,369 :: 		Read_Msg_Eeprom(0x0010);
	MOVLW      16
	MOVWF      FARG_Read_Msg_Eeprom_debut+0
	CALL       _Read_Msg_Eeprom+0
;12F1840_PWM_UART_140510.c,373 :: 		Ratio=0;
	CLRF       _Ratio+0
;12F1840_PWM_UART_140510.c,374 :: 		PWM1_Init(5000L);   PWM1_Set_Duty(Ratio);
	BSF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      199
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
	MOVF       _Ratio+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;12F1840_PWM_UART_140510.c,375 :: 		PWM1_Start();
	CALL       _PWM1_Start+0
;12F1840_PWM_UART_140510.c,377 :: 		Read_Msg_Eeprom(0x0050);
	MOVLW      80
	MOVWF      FARG_Read_Msg_Eeprom_debut+0
	CALL       _Read_Msg_Eeprom+0
;12F1840_PWM_UART_140510.c,378 :: 		CRLF();
	CALL       _CRLF+0
;12F1840_PWM_UART_140510.c,403 :: 		i1=0;
	CLRF       _i1+0
	CLRF       _i1+1
;12F1840_PWM_UART_140510.c,404 :: 		buffer[0]='P';     // reglage par Potar par defaut
	MOVLW      80
	MOVWF      _buffer+0
;12F1840_PWM_UART_140510.c,405 :: 		p1=buffer;
	MOVLW      _buffer+0
	MOVWF      _p1+0
	MOVLW      hi_addr(_buffer+0)
	MOVWF      _p1+1
;12F1840_PWM_UART_140510.c,406 :: 		Index1=0;
	CLRF       _Index1+0
	CLRF       _Index1+1
;12F1840_PWM_UART_140510.c,407 :: 		Read_Msg_Eeprom(0x0040);   CRLF();
	MOVLW      64
	MOVWF      FARG_Read_Msg_Eeprom_debut+0
	CALL       _Read_Msg_Eeprom+0
	CALL       _CRLF+0
;12F1840_PWM_UART_140510.c,408 :: 		INTCON.PEIE=1;  // autorise IT des peripherique voir fig  8.1 p 77
	BSF        INTCON+0, 6
;12F1840_PWM_UART_140510.c,409 :: 		PIE1.RCIE=1;
	BSF        PIE1+0, 5
;12F1840_PWM_UART_140510.c,410 :: 		INTCON.GIE=1;   // Enable all interrupts (timer1 & UART)
	BSF        INTCON+0, 7
;12F1840_PWM_UART_140510.c,412 :: 		while(1)
L_main29:
;12F1840_PWM_UART_140510.c,414 :: 		Init_Timer1 ();    //init pour 1ec
	CALL       _Init_Timer1+0
;12F1840_PWM_UART_140510.c,415 :: 		Flag_Buffer=0;
	CLRF       _Flag_Buffer+0
	CLRF       _Flag_Buffer+1
;12F1840_PWM_UART_140510.c,416 :: 		p1=&buffer[0];
	MOVLW      _buffer+0
	MOVWF      _p1+0
	MOVLW      hi_addr(_buffer+0)
	MOVWF      _p1+1
;12F1840_PWM_UART_140510.c,417 :: 		PWM1_Set_Duty(Ratio);
	MOVF       _Ratio+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;12F1840_PWM_UART_140510.c,418 :: 		while (Flag_Timer1==0);
L_main31:
	MOVLW      0
	XORWF      _Flag_Timer1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main58
	MOVLW      0
	XORWF      _Flag_Timer1+0, 0
L__main58:
	BTFSS      STATUS+0, 2
	GOTO       L_main32
	GOTO       L_main31
L_main32:
;12F1840_PWM_UART_140510.c,419 :: 		if (Flag_Buffer==1)
	MOVLW      0
	XORWF      _Flag_Buffer+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main59
	MOVLW      1
	XORWF      _Flag_Buffer+0, 0
L__main59:
	BTFSS      STATUS+0, 2
	GOTO       L_main33
;12F1840_PWM_UART_140510.c,421 :: 		Read_Msg_Eeprom(0x0030);
	MOVLW      48
	MOVWF      FARG_Read_Msg_Eeprom_debut+0
	CALL       _Read_Msg_Eeprom+0
;12F1840_PWM_UART_140510.c,423 :: 		UART1_Write_Text(buffer);
	MOVLW      _buffer+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(_buffer+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;12F1840_PWM_UART_140510.c,424 :: 		CRLF();
	CALL       _CRLF+0
;12F1840_PWM_UART_140510.c,425 :: 		k=strlen(buffer);
	MOVLW      _buffer+0
	MOVWF      FARG_strlen_s+0
	MOVLW      hi_addr(_buffer+0)
	MOVWF      FARG_strlen_s+1
	CALL       _strlen+0
	MOVF       R0, 0
	MOVWF      _k+0
	MOVF       R1, 0
	MOVWF      _k+1
;12F1840_PWM_UART_140510.c,427 :: 		p1=&buffer[0];
	MOVLW      _buffer+0
	MOVWF      _p1+0
	MOVLW      hi_addr(_buffer+0)
	MOVWF      _p1+1
;12F1840_PWM_UART_140510.c,428 :: 		i1=0;
	CLRF       _i1+0
	CLRF       _i1+1
;12F1840_PWM_UART_140510.c,429 :: 		Index1=0;
	CLRF       _Index1+0
	CLRF       _Index1+1
;12F1840_PWM_UART_140510.c,430 :: 		Flag_Buffer=0;
	CLRF       _Flag_Buffer+0
	CLRF       _Flag_Buffer+1
;12F1840_PWM_UART_140510.c,431 :: 		}
L_main33:
;12F1840_PWM_UART_140510.c,432 :: 		if ((buffer[0]=='S') && (k==4))
	MOVF       _buffer+0, 0
	XORLW      83
	BTFSS      STATUS+0, 2
	GOTO       L_main36
	MOVLW      0
	XORWF      _k+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main60
	MOVLW      4
	XORWF      _k+0, 0
L__main60:
	BTFSS      STATUS+0, 2
	GOTO       L_main36
L__main42:
;12F1840_PWM_UART_140510.c,434 :: 		i=isdigit(buffer[1]) + isdigit(buffer[2])+ isdigit(buffer[3]) ;
	MOVF       _buffer+1, 0
	MOVWF      FARG_isdigit_character+0
	CALL       _isdigit+0
	MOVF       R0, 0
	MOVWF      FLOC__main+0
	MOVF       _buffer+2, 0
	MOVWF      FARG_isdigit_character+0
	CALL       _isdigit+0
	MOVF       R0, 0
	ADDWF      FLOC__main+0, 1
	CLRF       FLOC__main+1
	MOVLW      0
	ADDWFC     FLOC__main+1, 1
	MOVF       _buffer+3, 0
	MOVWF      FARG_isdigit_character+0
	CALL       _isdigit+0
	MOVF       R0, 0
	ADDWF      FLOC__main+0, 0
	MOVWF      R1
	MOVLW      0
	ADDWFC     FLOC__main+1, 0
	MOVWF      R2
	MOVF       R1, 0
	MOVWF      _i+0
	MOVF       R2, 0
	MOVWF      _i+1
;12F1840_PWM_UART_140510.c,435 :: 		buffer[4]=0;
	CLRF       _buffer+4
;12F1840_PWM_UART_140510.c,436 :: 		if (i==3) Ratio=  atoi(&buffer[1]) ;
	MOVLW      0
	XORWF      R2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main61
	MOVLW      3
	XORWF      R1, 0
L__main61:
	BTFSS      STATUS+0, 2
	GOTO       L_main37
	MOVLW      _buffer+1
	MOVWF      FARG_atoi_s+0
	MOVLW      hi_addr(_buffer+1)
	MOVWF      FARG_atoi_s+1
	CALL       _atoi+0
	MOVF       R0, 0
	MOVWF      _Ratio+0
L_main37:
;12F1840_PWM_UART_140510.c,437 :: 		UART1_Write(TAB);
	MOVLW      9
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;12F1840_PWM_UART_140510.c,438 :: 		Read_Msg_Eeprom(0x00D0);
	MOVLW      208
	MOVWF      FARG_Read_Msg_Eeprom_debut+0
	CALL       _Read_Msg_Eeprom+0
;12F1840_PWM_UART_140510.c,439 :: 		UART1_Write(TAB);
	MOVLW      9
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;12F1840_PWM_UART_140510.c,440 :: 		WordToStr(Ratio, txt) ;
	MOVF       _Ratio+0, 0
	MOVWF      FARG_WordToStr_input+0
	CLRF       FARG_WordToStr_input+1
	MOVF       _txt+0, 0
	MOVWF      FARG_WordToStr_output+0
	MOVF       _txt+1, 0
	MOVWF      FARG_WordToStr_output+1
	CALL       _WordToStr+0
;12F1840_PWM_UART_140510.c,441 :: 		UART1_Write_Text(txt);
	MOVF       _txt+0, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVF       _txt+1, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;12F1840_PWM_UART_140510.c,442 :: 		}
	GOTO       L_main38
L_main36:
;12F1840_PWM_UART_140510.c,445 :: 		if (buffer[0]=='P')
	MOVF       _buffer+0, 0
	XORLW      80
	BTFSS      STATUS+0, 2
	GOTO       L_main39
;12F1840_PWM_UART_140510.c,447 :: 		M=ADC_Get_Sample(3);  // lecture AN3 sur RA4
	MOVLW      3
	MOVWF      FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0, 0
	MOVWF      _M+0
	MOVF       R1, 0
	MOVWF      _M+1
;12F1840_PWM_UART_140510.c,448 :: 		Ratio= M >>2 ;
	MOVF       R0, 0
	MOVWF      R2
	MOVF       R1, 0
	MOVWF      R3
	LSRF       R3, 1
	RRF        R2, 1
	LSRF       R3, 1
	RRF        R2, 1
	MOVF       R2, 0
	MOVWF      _Ratio+0
;12F1840_PWM_UART_140510.c,449 :: 		Read_Msg_Eeprom(0x0020);
	MOVLW      32
	MOVWF      FARG_Read_Msg_Eeprom_debut+0
	CALL       _Read_Msg_Eeprom+0
;12F1840_PWM_UART_140510.c,451 :: 		txt=TEXTE;
	MOVLW      _Texte+0
	MOVWF      _txt+0
	MOVLW      hi_addr(_Texte+0)
	MOVWF      _txt+1
;12F1840_PWM_UART_140510.c,452 :: 		WordToStr(M, txt) ;
	MOVF       _M+0, 0
	MOVWF      FARG_WordToStr_input+0
	MOVF       _M+1, 0
	MOVWF      FARG_WordToStr_input+1
	MOVF       _txt+0, 0
	MOVWF      FARG_WordToStr_output+0
	MOVF       _txt+1, 0
	MOVWF      FARG_WordToStr_output+1
	CALL       _WordToStr+0
;12F1840_PWM_UART_140510.c,453 :: 		UART1_Write_Text(txt);
	MOVF       _txt+0, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVF       _txt+1, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;12F1840_PWM_UART_140510.c,454 :: 		UART1_Write(TAB);
	MOVLW      9
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;12F1840_PWM_UART_140510.c,455 :: 		WordToStr(Ratio, txt) ;
	MOVF       _Ratio+0, 0
	MOVWF      FARG_WordToStr_input+0
	CLRF       FARG_WordToStr_input+1
	MOVF       _txt+0, 0
	MOVWF      FARG_WordToStr_output+0
	MOVF       _txt+1, 0
	MOVWF      FARG_WordToStr_output+1
	CALL       _WordToStr+0
;12F1840_PWM_UART_140510.c,456 :: 		UART1_Write_Text(txt);
	MOVF       _txt+0, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVF       _txt+1, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;12F1840_PWM_UART_140510.c,457 :: 		}
L_main39:
;12F1840_PWM_UART_140510.c,458 :: 		}
L_main38:
;12F1840_PWM_UART_140510.c,459 :: 		CRLF();
	CALL       _CRLF+0
;12F1840_PWM_UART_140510.c,460 :: 		} // while (1)
	GOTO       L_main29
;12F1840_PWM_UART_140510.c,462 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
