#line 1 "C:/_MickroC/_MesProjets_MickroC/_12F1840_PWM/12F1840_PWM_UART_140510.c"
#line 1 "c:/program files/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 88 "C:/_MickroC/_MesProjets_MickroC/_12F1840_PWM/12F1840_PWM_UART_140510.c"
const code char mesg0[]="Mikroc pro 6.01  Test PWM  12F1840 10-05-2014\n\r";
const code char mesg1[]="...";
const code char * Messages[]={mesg0,mesg1};

const char levels[8] = {23, 52, 81, 110, 139, 168, 197, 226};

const char txt1[]="Hello world";

volatile unsigned char buffer[64];
volatile unsigned char * p1;
char Texte[64];
char *txt;
unsigned short error;
volatile unsigned int CptErr;

volatile unsigned int i1;
volatile unsigned int Count1;
volatile unsigned int Count2;
volatile int Flag_Timer1;
volatile int Flag_Timer2;
volatile int Flag_Buffer;
volatile int Index1;
volatile unsigned char c1;

unsigned int i,j,k;
unsigned int M;




unsigned char Ratio;


void strConstRamCpy(unsigned char *dest, const code char *source);
void CRLF(void);
void interrupt(void) ;


void Read_Msg_Eeprom(unsigned char depuis);
void Init_Timer0(void);
void Init_Timer1 (void);
void Init_Timer2 (void);




void interrupt(void) org 0x04
{
 if ( (RCIE_bit) && ( RCIF_bit))
 {

 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 c1 = RCREG;
 RCSTA.CREN = 1 ;
 CptErr++;

 }
 if(RCSTA.FERR==1 )
 {
 RCSTA.SPEN = 0 ;
 RCSTA.SPEN= 1 ;
 CptErr++;
 c1 = RCREG;
 }
 c1 = RCREG;
 if (c1== 13 )
 {
 Flag_Buffer=1;

 buffer[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 buffer[i1]=c1;
 Index1=i1;
 i1++;

 }
 PIR1.RCIF=0 ;
 }

 if ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
 {

 Count1++;
 if (Count1>= 8 )
 {
 Count1=0;
 Flag_Timer1=1;
 TMR1IE_bit=0;
 }
 TMR1H= 0x0B;
 TMR1L= 0xDB;
 PIR1.TMR1IF=0;
 }
#line 204 "C:/_MickroC/_MesProjets_MickroC/_12F1840_PWM/12F1840_PWM_UART_140510.c"
 }


void strConstRamCpy(unsigned char *dest, const code char *source) {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}

void CRLF()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

void UART1_Write_CText(const char *txt) {
 while (*txt)
 UART1_Write(*txt++);
}


void Read_Msg_Eeprom(unsigned char debut)
{ int i1 ,i;
 i1=debut;
 do
 {
 i = EEPROM_Read(i1);
 if ( i==0) break;
 if ( i1>254) break;
 UART1_Write(i);
 delay_ms(5);
 i1++;
 }
 while (i!=0) ;
 }

 void Init_Timer0(void)
 {

 OPTION_REG.PS2=1;
 OPTION_REG.PS1=1;
 OPTION_REG.PS0=1;
 OPTION_REG.PSA=0;
 OPTION_REG.TMR0CS=0;
 INTCON.TMR0IF=0;
 INTCON.TMR0IE=0;
 TMR0= 255 ;
 CPSCON0=0;
 }

void Init_Timer1(void)
 {
 T1CON=0;

 TMR1CS0_bit=0;
 TMR1CS1_bit=0;
 T1CKPS1_bit=1;
 T1CKPS0_bit=1;
 T1GCON=0;
 TMR1H= 0x0B;
 TMR1L= 0xDB;


 Count1=0;
 Flag_Timer1=0;
 PIR1.TMR1IF=0;
 PIE1.TMR1IE=1;
 TMR1ON_bit=1;
}

 void Init_Timer2(void)
 {
 T2CON=0;
 T2OUTPS0_bit=1;
 T2OUTPS1_bit=1;
 T2OUTPS2_bit=1;
 T2OUTPS3_bit=1;
 T2CKPS1_bit=1;
 T2CKPS0_bit=1;
 TMR2= 60;
 Count2=0;
 Flag_Timer2=0;
 TMR2IF_bit=0;
 TMR2IE_bit=0;
 TMR2ON_bit=1;
}

char ValToLevel(char val) {
char i = 0;
while (i < sizeof(levels)) {
if (val < levels[i])
return i;
i++;
}

return sizeof(levels);
}

void main(void)
{



 OSCCON=0b01111010;
 ANSELA=0;
 ANSELA.ANSA4=1;
 TRISA= 0b00011111;
 WPUA=0b00111111;
 CM1CON0=0;
 CM1CON1=0;
 CCP1CON=0;

 APFCON=0;
 APFCON.P1BSEL=1;
 APFCON.RXDTSEL=0;
 APFCON.TXCKSEL=0;
 APFCON.CCP1SEL=0;



 FVRCON.FVREN=1;
 FVRCON.TSEN=0;
 FVRCON.TSRNG=1;
 FVRCON.CDAFVR1=0;
 FVRCON.CDAFVR0=0;


 FVRCON.ADFVR1=1;
 FVRCON.ADFVR0=1;


 RCSTA=0;
 RCSTA.CREN=1;
 RCSTA.SPEN=1;
 RCSTA.SREN=1;
 c1 = RCREG;

 p1=&buffer[0];

 INTCON=0;
 PIR1=0;
 PIR2=0;
 INTCON.PEIE=1;
 INTCON.GIE=0;

 txt=&Texte[0];
 UART1_Init(19200);

 while(PIR1.RCIF==1) c1 = RCREG;

 UART1_Write( 13 );
 delay_ms(1000);
;
 txt=&Texte[0];
 strConstRamCpy(txt, mesg0);
 UART1_Write_Text(txt);
 delay_ms(1000);

 Read_Msg_Eeprom(0x0000); txt=&Texte[0]; delay_ms(1000);

 ADC_Init();


 ADCON1.ADPREF1= 1;
 ADCON1.ADPREF0= 1;

 Read_Msg_Eeprom(0x0010);



 Ratio=0;
 PWM1_Init(5000L); PWM1_Set_Duty(Ratio);
 PWM1_Start();

 Read_Msg_Eeprom(0x0050);
 CRLF();
#line 403 "C:/_MickroC/_MesProjets_MickroC/_12F1840_PWM/12F1840_PWM_UART_140510.c"
 i1=0;
 buffer[0]='P';
 p1=buffer;
 Index1=0;
 Read_Msg_Eeprom(0x0040); CRLF();
 INTCON.PEIE=1;
 PIE1.RCIE=1;
 INTCON.GIE=1;

 while(1)
 {
 Init_Timer1 ();
 Flag_Buffer=0;
 p1=&buffer[0];
 PWM1_Set_Duty(Ratio);
 while (Flag_Timer1==0);
 if (Flag_Buffer==1)
 {
 Read_Msg_Eeprom(0x0030);

 UART1_Write_Text(buffer);
 CRLF();
 k=strlen(buffer);

 p1=&buffer[0];
 i1=0;
 Index1=0;
 Flag_Buffer=0;
 }
 if ((buffer[0]=='S') && (k==4))
 {
 i=isdigit(buffer[1]) + isdigit(buffer[2])+ isdigit(buffer[3]) ;
 buffer[4]=0;
 if (i==3) Ratio= atoi(&buffer[1]) ;
 UART1_Write( 9 );
 Read_Msg_Eeprom(0x00D0);
 UART1_Write( 9 );
 WordToStr(Ratio, txt) ;
 UART1_Write_Text(txt);
 }
 else
 {
 if (buffer[0]=='P')
 {
 M=ADC_Get_Sample(3);
 Ratio= M >>2 ;
 Read_Msg_Eeprom(0x0020);

 txt=TEXTE;
 WordToStr(M, txt) ;
 UART1_Write_Text(txt);
 UART1_Write( 9 );
 WordToStr(Ratio, txt) ;
 UART1_Write_Text(txt);
 }
 }
 CRLF();
 }

}
