  /*
   10-05-2014
   Reglage par Potentiometre par defaut
   sinon via uart terminal  via les commandes :
   Sxxx<CR>  Set PWM with value XXX  (XXX = 000  255)
   P<CR> reglage via potar
   
 09/05-2014
 test PWM ... utilise Timer2 !!
 Timer1 en IT 1sec ..OK
 PB: pas de reception UART1!
     et allea de fonctionnement UART avec PWM en service
      allant jusqu'au plantage MCU
      Rajout de 470F et 100nF en //  sur alim 5V (deja regule!)
      mais toujours pas d'interrupt reception !
 Rajour R pull up de 6,2K entre RA1 pin6 et +5V
        malgre l'activation de WPUA
        La breadboard presente 2  3pF entre RA2 sortie PWM et Entree RX !!!
        car les 2 pin MCU sont cote  cote..
         nota: usage de interface-2T pour TTL/RS232 
Reception USART ...  OK apres cette modif 
 
   Projet :  12F1840_PWM.mcppi
   SW:       mikroC PRO for PIC   V 6.1
   MCU :         PIC12F1840  ehanced type
   Directory :   C:\_MickroC\_MesProjets_MickroC\_12F1840_PWM
   Source :      12F1840_PWM_UART_140510.c
   EEPROM :      12F1840_PWM.c.ihex   
   Programmateur tools : PicKit2 V2.61 (choose 1,8V family!)
   config bits:     P18F1840_16MHZ.cfgsch
   CONFIG1   :$8007 : 0x29E4
   CONFIG2   :$8008 : 0x3613

   config vu par Pickit2 :  2984 3613 <- OK
   VDD    : 5,0V    
   horloge  :  interne  16 MHz ... pas de quartz
   Librairies utilisees :
   - built_in.h
   - UART
   - C_String
   - Conversions
   - ADC
   - PWM

 
  28 avril 2014 ... MikroC Pro version Enregistre !!! no more limit
  Hardware
  12F1840                                                                  BT pin 6 N.C.
  pin 1     VDD Alim +5.0   ATTENTION !!!!!!!!!!!!!!    ----- CONV 5V/3V---BT pin 5 3,3V
  pin 2     RA5 -- output ---->  HC06 RESET   fil soud direct sur --------BT cot composant pin 11 
  pin 3     RA4 <--- AN3 Analog input  <--  capteur Temper LM335
  pin 4     RA3/MCLR/VPP -- ICSP Reset   R=5.6K  de rappel au +3,3V
  pin 5     RA2 --->  PWM output  ---IRFZ14 -- lampe
  pin 6     RA1  ICSP Clock  &  input RX <------TX bluetooth   =  emission BT pin 3    TX
  pin 7     RAO  ICSPDAT  &   TX ------1500 ohms-> RX bluetooth  = reception BT  pin 2   RX
  pin 8     VSS alim 0V  -----------------------------------------------   BT pin 4    OV
                                                      ------------------   BT pin 1    N.C.
  nota: pull up de 6,2K sur pin 6 RA1 RX  , permet de fixer le potentiel un peu mieux qu'avec WPA
         et evite le passage parasite PWM via la capa de 2pF de la breadboard
                                                                      
                                                                       
*/                        
   //ac:Pinout_12F1840
  
   //ac:_12F1840_PWM_UART_Sch
    
   //ac:Timer2
   
   //ac:IRFZ14_mosfet
 
 
#include "built_in.h"     // for  Hi  Lo ..etc
  
#define TAB 9
#define CLS 12
#define CR 13
#define LF 10
#define STX 2
#define ETX 3

#define POWER_SUPPLY_5V
#define FOSC 16.0  // MHz
#define BAUD 19200  // UART1

// RA5 direct sur circuit imprim RESET HC06
#define Reset_BT_HC06 LATA5_bit     

const code char mesg0[]="Mikroc pro 6.01  Test PWM  12F1840 10-05-2014\n\r";
const code char mesg1[]="...";
const code char * Messages[]={mesg0,mesg1};

const char levels[8] = {23, 52, 81, 110, 139, 168, 197, 226};

const char txt1[]="Hello world";

volatile unsigned char buffer[64];        // besoin de 165 car !
volatile unsigned  char * p1;
char Texte[64]; 
char *txt;
unsigned short error;
volatile unsigned int CptErr;

volatile unsigned int i1;
volatile unsigned int Count1;
volatile unsigned int Count2;
volatile int Flag_Timer1;
volatile int Flag_Timer2;
volatile int Flag_Buffer;
volatile int Index1;
volatile  unsigned char c1;

unsigned int i,j,k;
unsigned int M;

#define  NbCycles_T1 8     // 20 x 50mS pour faire 1 sec
#define  NbCycles_T2 20     // 20 x 50mS pour faire 1 sec

unsigned char Ratio;


void strConstRamCpy(unsigned char *dest, const code char *source);
void CRLF(void);
void interrupt(void) ;

//void Init_Timer1(void);
void Read_Msg_Eeprom(unsigned char depuis);
void Init_Timer0(void);
void Init_Timer1 (void);    //125mS
void Init_Timer2 (void);    //125mS



 
void interrupt(void)  org 0x04
{
 if ( (RCIE_bit) && ( RCIF_bit))
   {
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
        CptErr++;
     
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
      c1 = RCREG;
     if (c1==CR)
      {
      Flag_Buffer=1;
      //PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer[i1]=c1;
        Index1=i1;
        i1++;
       
      }
     PIR1.RCIF=0   ;
   }
  // ------  timer 1  ----------------
  if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag

     Count1++;
     if (Count1>=NbCycles_T1)   // 8x125 ms= 1 seconde   et init timer1  3035  et prescaler=1/8
       {
        Count1=0;
        Flag_Timer1=1;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   } 
   /*
   ------  timer 2 ----------------
  if( ((TMR2IE_bit==1)&& TMR2IF_bit==1))
  {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag

     Count2++;
     if (Count2>=NbCycles_T2)   // 8x125 ms= 1 seconde   et init timer1  3035  et prescaler=1/8
       {
        Count2=0;
        Flag_Timer2=1;
      }
      TMR2= 60;
      PIR1.TMR2IF=0;
   } 
   */
   
 }

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source) {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt) {
   while (*txt)
      UART1_Write(*txt++);
}

 
void Read_Msg_Eeprom(unsigned char debut)
{   int i1 ,i;
  i1=debut;
  do
  {
  i = EEPROM_Read(i1);
  if ( i==0) break;
  if ( i1>254) break;
  UART1_Write(i);
  delay_ms(5);
  i1++;
   }
  while (i!=0) ;
 }

 void Init_Timer0(void)    // 1 seconde
 {
 
 OPTION_REG.PS2=1;   // prescaler 1/256
 OPTION_REG.PS1=1;
 OPTION_REG.PS0=1;
 OPTION_REG.PSA=0; // prescaler sur Timer0
 OPTION_REG.TMR0CS=0; // source FOSC/4
 INTCON.TMR0IF=0;
 INTCON.TMR0IE=0;    // disable interrupt Timer0
 TMR0= 255 ; //  255-0=255  prescaler=1/256 => 16.384 mS
 CPSCON0=0;
 }

void Init_Timer1(void)    
 {
  T1CON=0;
 // T1CON=0b00110000; 
  TMR1CS0_bit=0;   // FOSC internal / 4
  TMR1CS1_bit=0;
  T1CKPS1_bit=1;  //prescal select=11 => 1/8
  T1CKPS0_bit=1;
  T1GCON=0; 
  TMR1H= 0x0B; // Hi (3035);
  TMR1L= 0xDB; // Lo (3035);
 // TMR1H= NbCycles_T1>>8;
 // TMR1L= NbCycles_T1 & 0x00FF;
   Count1=0; 
  Flag_Timer1=0;
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  PIE1.TMR1IE=1;  //Enable interrupt TMR1
  TMR1ON_bit=1;
}
 
 void Init_Timer2(void)    
 {
  T2CON=0;
  T2OUTPS0_bit=1;     // postscaleer =1/16
  T2OUTPS1_bit=1;   
  T2OUTPS2_bit=1;    
  T2OUTPS3_bit=1;  
  T2CKPS1_bit=1;  //prescaler select=11 => 1/64
  T2CKPS0_bit=1;
  TMR2=   60;     // 49.92mS @ 16MHz
  Count2=0; 
  Flag_Timer2=0;
  TMR2IF_bit=0;     // Reset Timer1 Flag
  TMR2IE_bit=0;  //Enable interrupt TMR1
  TMR2ON_bit=1;
}

char ValToLevel(char val) {
char i = 0;
while (i < sizeof(levels)) {
if (val < levels[i])
return i;
i++;
}

return sizeof(levels);
}

void main(void)
{
                       // voir page 61
  // 0=4xPLL OFF, 1111=IOFS=16Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  // 0=4xPLL OFF, 1110=IOFS=8Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  OSCCON=0b01111010;    // choix 16Mhz  internal osc
  ANSELA=0;             // no analog
  ANSELA.ANSA4=1;       // RA4= Analog input
  TRISA= 0b00011111;    // RA0,1,,3,4 as input     RA2 as output PWM, RA5 as output  TX
  WPUA=0b00111111;      // weak pull up on RX & TX  et RA2
  CM1CON0=0;       // disable comparators
  CM1CON1=0;
  CCP1CON=0;       // indispensable pour UART sur RA0

  APFCON=0;
  APFCON.P1BSEL=1;    // pour deconnecter de RA0 mais connecte sur RA4 ???!!
  APFCON.RXDTSEL=0;   // RX sur RA1
  APFCON.TXCKSEL=0;   // TX sur RA0
  APFCON.CCP1SEL=0;   // PWM output pin  0=RA2   1=RA4
  

  // because power supply is 5V 
  FVRCON.FVREN=1;       // enable fixed voltage reference     (voir page 124)
  FVRCON.TSEN=0;        // temperature enable=0;
  FVRCON.TSRNG=1;       // temperature range high   car VDD>3,6V
  FVRCON.CDAFVR1=0;     // Comparator & DAC OFF
  FVRCON.CDAFVR0=0;
 // FVRCON.ADFVR1=0;     // ref is OFF in case of LM335  2730mV art 0C
 // FVRCON.ADFVR0=0;
  FVRCON.ADFVR1=1;     // ref=4.096V
  FVRCON.ADFVR0=1;
  
  
  RCSTA=0;
  RCSTA.CREN=1;  //enable receiver
  RCSTA.SPEN=1;  // serial port Pins Enable
  RCSTA.SREN=1;  // single bit receive
  c1 = RCREG;   // RAZ errors
  
  p1=&buffer[0];

   INTCON=0;
   PIR1=0;
   PIR2=0;
   INTCON.PEIE=1;  // disable IT des peripherique voir fig  8.1 p 77
   INTCON.GIE=0;

   txt=&Texte[0];
   UART1_Init(19200);
   // vide tampon fifo
   while(PIR1.RCIF==1) c1 = RCREG;  
  // UART_Set_Active(&UART1_Read, &UART1_Write, &UART1_Data_Ready, &UART1_Tx_Idle); // set UART1 active
   UART1_Write(CR);//TXREG=CLS;
   delay_ms(1000);
;
  txt=&Texte[0];
  strConstRamCpy(txt, mesg0);
  UART1_Write_Text(txt);
  delay_ms(1000);

   Read_Msg_Eeprom(0x0000);   txt=&Texte[0];   delay_ms(1000);

   ADC_Init();
  // ADCON1.ADPREF1= 0;  // Vref sur VDD
 //  ADCON1.ADPREF0= 0;
   ADCON1.ADPREF1= 1;  // Vref sur FVR 4.096V
   ADCON1.ADPREF0= 1;
    
   Read_Msg_Eeprom(0x0010); 
 
  // Init_Timer1() ; 

   Ratio=0;
   PWM1_Init(5000L);   PWM1_Set_Duty(Ratio);
   PWM1_Start();
   //PWM1_Stop();
    Read_Msg_Eeprom(0x0050); 
    CRLF();

  /*
  CRLF();
  strConstRamCpy(txt, "TEXT1 EN DUR en ROM\r\n");
  UART1_Write_Text( txt);
  strConstRamCpy(txt, "TEXT2 EN DUR en ROM\r\n");
  UART1_Write_Text(txt);
  strConstRamCpy(txt, "TEXT3 EN DUR en ROM\r\n");
  UART1_Write_Text( txt);
   strConstRamCpy(txt, "TEXT4 EN DUR en ROM\r\n");
  UART1_Write_Text( txt);
  strConstRamCpy(txt, "TEXT5 EN DUR en ROM\r\n");
  UART1_Write_Text(txt);
  strConstRamCpy(txt, "TEXT6 EN DUR en ROM\r\n");
  UART1_Write_Text( txt); strConstRamCpy(txt, "TEXT1 EN DUR en ROM\r\n");
  UART1_Write_Text( txt);
  strConstRamCpy(txt, "TEXT7 EN DUR en ROM\r\n");
  UART1_Write_Text(txt);
  strConstRamCpy(txt, "TEXT8 EN DUR en ROM\r\n");
  UART1_Write_Text( txt);
  CRLF();
 */ 
  

  i1=0;
  buffer[0]='P';     // reglage par Potar par defaut
  p1=buffer;
  Index1=0;
  Read_Msg_Eeprom(0x0040);   CRLF();
  INTCON.PEIE=1;  // autorise IT des peripherique voir fig  8.1 p 77
  PIE1.RCIE=1;
  INTCON.GIE=1;   // Enable all interrupts (timer1 & UART)
   
  while(1) 
  {
    Init_Timer1 ();    //init pour 1ec
     Flag_Buffer=0;
     p1=&buffer[0];
     PWM1_Set_Duty(Ratio);
     while (Flag_Timer1==0);
     if (Flag_Buffer==1)
      {
       Read_Msg_Eeprom(0x0030); 
       // UART1_Write_Text((const char *)" Recu UART1 :\n\r"); 
       UART1_Write_Text(buffer);
       CRLF();
       k=strlen(buffer);
        //buffer[0]=0; // laisse le buffer sur sa derniere valeur !!
       p1=&buffer[0];
       i1=0;
       Index1=0;
       Flag_Buffer=0;
      } 
      if ((buffer[0]=='S') && (k==4))
      {
          i=isdigit(buffer[1]) + isdigit(buffer[2])+ isdigit(buffer[3]) ;
          buffer[4]=0;
          if (i==3) Ratio=  atoi(&buffer[1]) ;
          UART1_Write(TAB); 
          Read_Msg_Eeprom(0x00D0);
          UART1_Write(TAB); 
          WordToStr(Ratio, txt) ;
          UART1_Write_Text(txt); 
        }   
      else
       {
            if (buffer[0]=='P') 
            {
             M=ADC_Get_Sample(3);  // lecture AN3 sur RA4
             Ratio= M >>2 ; 
             Read_Msg_Eeprom(0x0020);  
             // UART1_Write(TAB);
             txt=TEXTE;
             WordToStr(M, txt) ;
             UART1_Write_Text(txt);  
             UART1_Write(TAB); 
             WordToStr(Ratio, txt) ;
             UART1_Write_Text(txt);
            }
        }  
      CRLF();     
  } // while (1)
    
}
/*

Mikroc pro 6.01  Test PWM  12F1840 10-05-2014
Init UART1 1
Init ADC0 
Init PWM on RA2
Arme Interrupts
Pot ADC0=            22            5
Pot ADC0=            21            5
Pot ADC0=            21            5
Recep UART1 =  S001
        Keyb set PWM=              1
        Keyb set PWM=              1
        Keyb set PWM=              1
        Keyb set PWM=              1
Recep UART1 =  S128
        Keyb set PWM=            128
        Keyb set PWM=            128
        Keyb set PWM=            128
Recep UART1 =  S254
        Keyb set PWM=            254
        Keyb set PWM=            254
        Keyb set PWM=            254
Recep UART1 =  P
Pot ADC0=            20            5
Pot ADC0=            21            5
Pot ADC0=            86           21
Pot ADC0=           166           41
Pot ADC0=           230           57
Pot ADC0=           312           78
Pot ADC0=           419          104
Pot ADC0=           578          144
Pot ADC0=           675          168
Pot ADC0=           865          216
Pot ADC0=           951          237
Pot ADC0=          1023          255
Pot ADC0=          1023          255
Pot ADC0=           479          119
Pot ADC0=            36            9
Pot ADC0=            47           11
Pot ADC0=            43           10

==============================================================

test avec Hexfet IRLZ14 commande ampoule
consigne PWM via potar sur AN3 
cd OK de 0  100% 
PWM_Init value   Freqmeter
         1000             250
         2000             500
         3000             745
         3500             869
         -----------------
         4000             4000
         5000             5000
         20000            20033
         40000            40049
         80000            80132
         100000           100165
 ----------------------
 
 sans R de 6,2K sur RA1 pin 6
 18:43:40.515> ect ADC0=           S
Lect ADC0=           34Lect ADC0=          SLect ADC0= &1Lect ADC0=           29Lect ADC0=          S

plantage MCU !!
 =====================================
 
0 1 mikroCPIC1618.exe -MSF -DBG -pP12F1840 -DL -O11111015 -fo16 -N"C:\_MickroC\_MesProjets_MickroC\_12F1840\12F1840_PWM.mcppi" -EH"C:\_MickroC\_MesProjets_MickroC\_12F1840\12F1840_PWM.ihex" -SP"C:\Program Files\Mikroelektronika\mikroC PRO for PIC\defs\" -SP"C:\Program Files\Mikroelektronika\mikroC PRO for PIC\Uses\P16_Enh\" -SP"C:\_MickroC\_MesProjets_MickroC\_12F1840\" -SP"C:\_MickroC\_MesProjets_MickroC\_12F1840_PWM\" -SP"C:\_MickroC\_Docu\" "12F1840_PWM.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_Conversions.mcl" "__Lib_ADC.mcl" "__Lib_EEPROM.mcl" "__Lib_PWM_a2.mcl" "__Lib_UART_a01.mcl"  
0 1139 Available RAM: 240 [bytes], Available ROM: 4096 [bytes]  
0 126 All files Preprocessed in 62 ms  
0 122 Compilation Started 12F1840_PWM.c
0 1004 interrupt handler (interrupt at 0x0004) 12F1840_PWM.c
340 1509 Generated baud rate is 19231 bps (error = 0.16 percent) 12F1840_PWM.c
418 123 Compiled Successfully 12F1840_PWM.c
0 127 All files Compiled in 125 ms  
0 1144 Used RAM (bytes): 180 (75%)  Free RAM (bytes): 60 (25%) Used RAM (bytes): 180 (75%)  Free RAM (bytes): 60 (25%)
0 1144 Used ROM (program words): 1005 (25%)  Free ROM (program words): 3091 (75%) Used ROM (program words): 1005 (25%)  Free ROM (program words): 3091 (75%)
0 125 Project Linked Successfully 12F1840_PWM.mcppi
0 128 Linked in 125 ms  
0 129 Project '12F1840_PWM.mcppi' completed: 406 ms  
0 103 Finished successfully: 10 mai 2014, 14:43:42 12F1840_PWM.mcppi


  */